# Bridge photoshop

[![Team](https://img.shields.io/badge/team-neon-0F73EE.svg)](https://invisionapp.atlassian.net/projects/NEON)
![Status](https://img.shields.io/badge/status-active-green.svg)

Bridge is a global API object for communicating with the host environment accessed by `panel.*`. The Bridge api is same for all host environments, but its implementations differ.

You can find documentation of methods and properties [here](https://github.com/InVisionApp/panel-frontend/tree/next#properties--methods)

## Communication between `${plugin}-panel`, `${plugin}-photoshop` and potentially `${plugin}-generator`
Naturally, the three parts of the extension must somehow talk to each other. This part is handled by the Bridge. When `panel.emit` is called, the bridge looks into `pkg.panel.commands` for a handler. If no event identifier is matched, the event **will not** be emitted!

If the matched identifier has a flag `generatorEvent`, the event will be emitted through websocket to the generator part of the extension.

If the matched identifier contains a `handler` field (string), the bridge will look into `pkg.main` to check if a function with the given handler name exists. If yes, the handler gets executed with following parameters:

- `panel`: instance of bridge
- `data`: the second argument of `panel.emit`
- `callback`: an event will be emitted back from the bridge when called. The only argument this function receives is `result`, which can then be accessed in an event listener.

If the matched identifier contains a `handler` field but no function inside of `pkg.main` matches, the bridge will evaluate this as a Photoshop JSX function name and will call it with following parameters:

- `panel`: instance of bridge
- `data`: the second argument of `panel.emit`
