var classProperty  = charIDToTypeID("Prpr");
var propNull       = charIDToTypeID("null");
var classNull      = charIDToTypeID("null");
var typeOrdinal    = charIDToTypeID("Ordn");
var enumTarget     = charIDToTypeID("Trgt");
var classDocument  = charIDToTypeID("Dcmn");
var classLayer     = charIDToTypeID("Lyr ");
var propProperty   = stringIDToTypeID("property");
var actionSet      = charIDToTypeID("setd");
var actionGet      = charIDToTypeID("getd");
var keyTo          = charIDToTypeID("T   ");

function setSettings(params) {
  // These are the generator settings
  var generatorSettingsDesc = new ActionDescriptor();

  generatorSettingsDesc.putString(stringIDToTypeID('json'), JSON.stringify(params.settings))

  // Set the generator meta data.
  var theRef = new ActionReference();
  // Property needs to come first
  theRef.putProperty(classProperty, stringIDToTypeID("generatorSettings"));

  if (params.layerId) {
      theRef.putIdentifier(classLayer, params.layerId);
  } else {
      theRef.putEnumerated(classDocument, typeOrdinal, enumTarget);
  }

  // Execute the set action setting the descriptor into the property reference
  var setDescriptor = new ActionDescriptor();
  setDescriptor.putReference(propNull, theRef);

  setDescriptor.putObject(keyTo, classNull, generatorSettingsDesc);
  if (params.key) {
      setDescriptor.putString(propProperty, params.key);
  }
  executeAction(actionSet, setDescriptor, DialogModes.NO);
}

function getSettings(params) {
  var theRef = new ActionReference();
  theRef.putProperty(classProperty, stringIDToTypeID("generatorSettings"));

  if (params.layerId) {
      theRef.putIdentifier(classLayer, params.layerId);
  }

  if (params.documentId) {
      theRef.putIdentifier(classDocument, params.documentId);
  } else {
      theRef.putEnumerated(classDocument, typeOrdinal, enumTarget);
  }

  var getDescriptor = new ActionDescriptor();
  getDescriptor.putReference(propNull, theRef);
  if (params.key) {
      getDescriptor.putString(propProperty, params.key);
  }

  var desc = executeAction(actionGet, getDescriptor, DialogModes.NO);
  var generatorSettings = actionDescriptorToObject(desc).generatorSettings;

  var jsonData = generatorSettings.json;
  if (jsonData) {
    return jsonData;
  } else {
    return '{}';
  }
}
