function actionDescriptorToObject(desc) {
  var obj = {};
  var len = desc.count;
  for(var i=0;i<len;i++){
    var key = desc.getKey(i);
    obj[typeIDToStringID(key)] = getValueByType(desc,key);
  }
  return obj;
}

// Get a value from an ActionDescriptor by a type defined by a key
// ALIASTYPE BOOLEANTYPE CLASSTYPE DOUBLETYPE ENUMERATEDTYPE INTEGERTYPE LARGEINTEGERTYPE LISTTYPE OBJECTTYPE RAWTYPE REFERENCETYPE STRINGTYPE UNITDOUBLE
function getValueByType(desc,key) {
  var type = desc.getType(key);
  var value = null;
  switch(type){
    case DescValueType.ALIASTYPE:
      value = "alias";
      break;
    case DescValueType.BOOLEANTYPE:
      value = desc.getBoolean(key);
      break;
    case DescValueType.CLASSTYPE:
      value = desc.getClass(key);
      break;
    case DescValueType.OBJECTTYPE:
      value = actionDescriptorToObject(desc.getObjectValue(key));//+" - "+desc.getObjectType(key);
      break;
    case DescValueType.ENUMERATEDTYPE:
      value = typeIDToStringID(desc.getEnumerationValue(key));
      break;
    case DescValueType.DOUBLETYPE:
      value = desc.getDouble(key);
      break;
    case DescValueType.INTEGERTYPE:
      value = desc.getInteger(key);
      break;
    case DescValueType.LARGEINTEGERTYPE:
      value = desc.getLargeInteger(key);
      break;
    case DescValueType.LISTTYPE:
      value = desc.getList(key);
      break;
    case DescValueType.RAWTYPE:
          // not implemented
      break;
    case DescValueType.REFERENCETYPE:
      value = desc.getReference(key);
      break;
    case DescValueType.STRINGTYPE:
      value = desc.getString(key);
      break;
    case DescValueType.UNITDOUBLE:
      value = desc.getUnitDoubleValue(key);
      break;
  }
  return value;
}
